#define KEY_NONE 0
#define KEY_RELEASE 255

#define SERIAL_BUFFERSIZE 80
#define MJ_FIFOSIZE 256
#define MJ_FIFO_A_SIZE 32

#define INFOSTRING "MouseJiggler-NG v 0.0.7 by Robert Resch 2019"

#include <Keyboard.h>
#include <Mouse.h>

#include "eeprom.h"
#include "text_to_number.h"
#include "fifo.h"
#include "taskmanager.h"
#include "parser.h"
#include "tasks.h"

void setup() {
  int i=0;

  // Initialize Serial Connection
  Serial.begin(9600);
  while (!Serial && i < 10) {
    delay(10);
    i++;
  }

  // seed the RNG with some garbish vom AD0
  randomSeed(analogRead(0));

  Mouse.begin();
  Keyboard.begin();

  delay(500);

  // Initialize Variables from EEPROM Settings
  if (mj_eeprom_check_crc() == false) {
    mj_eeprom_init_defaults();
  }
  mj_eeprom_get_config();

  // Get sure that there is no garbage in tasklist as we deal with function pointers...
  InitTasklist();

  // Add the needed tasks to the tasklist
  AddTask(writebuffer, (char *) "Writebuf");
  AddTask(processactions, (char *) "Actions");
  AddTask(led, (char *) "LEDBlink");
  AddTask(readser, (char *) "ReadSeri");
  AddTask(jiggler, (char *) "Jiggler");
  AddTask(buttons, (char *) "Buttons");
  AddTask(autotype, (char *)"AutoType");
}

// Main loop - only calls RunTasks()
void loop() {
  RunTasks();
}
